/* HTMLdtd.c
 * $Id: HTMLdtd.c,v 1.2 1995/07/14 15:57:20 connolly Exp $
 */


/* implements ... */
#include "HTMLdtd.h"

/* uses ... */
#include "SGML.h"
#include "object.h"

static HMBinding entities[] = {
#include "HTMLentities.c"
};

static HMBinding content[] = {
#include "HTMLcontent.c"
};

static int compare PARAMS((CONST VOIDPTR x, CONST VOIDPTR y));

static int
  compare(x, y)
CONST VOIDPTR x;
CONST VOIDPTR y;
{
  CONST char* xx = (CONST char*)x;
  CONST HMBinding* yy = (CONST HMBinding*)y;

  return strcmp(xx, yy->name);
}

CONST char*
  html_entity_text(unused, name)
HMDoc* unused;
CONST char* name;
{
  /* binary search through sorted list of entity names */

  CONST HMBinding *ed;

  ed = (CONST HMBinding*)bsearch(name, entities,
				 ARRAYSIZE(entities), sizeof(entities[0]),
				 compare);

  if(ed)
    return ed->value;
  else
    return 0;
}


int
  HTML_content(gi)
CONST char* gi;
{
  CONST HMBinding *ed;

  ed = (CONST HMBinding*)bsearch(gi, content,
				 ARRAYSIZE(content), sizeof(content[0]),
				 compare);

  if(ed)
    return (int)ed->value; /*@@ hack! store enum in char* */
  else
    return SGML_EMPTY;
}
